UNIT CCCPVGA;

{****************************************************************************}
{                                                                            }
{ Name        : UNIT CCPVGA                                                  }
{                                                                            }
{ Author      : Andreas Schrger                                             }
{                                                                            }
{ Version     : 3.0                                                          }
{                                                                            }
{ Date        : 03.04.96                                                     }
{                                                                            }
{ Info        :                                                              }
{                                                                            }
{****************************************************************************}


INTERFACE

 VAR hr,m,s,h,hr2,m2,s2,h2,zeitlauf : word;
     mili1,mili2,mili3 : longint;
     delta : shortint;

 CONST VGA = $a000;
       cccpvgaversion = 4;


 Type wolk   = Array [1..85*35] of byte;
 Type vgascreen = Array [1..320*200] of byte;
      palettetyp = array[0..255] of record
                                    r : byte;
                                    g : byte;
                                    b : byte;
                                    end;

 procedure Vertline(x,entf,where:word;color:byte);
 Procedure Putpixel (X,Y : word; Col : Byte;  where:word);
 Procedure SetPal(Col,R,G,B : Byte);
 Procedure GetPal(Col : Byte; Var R,G,B : Byte);
 Procedure WaitRetrace;
 Procedure SetMCGA;
 Procedure SetText;
 Procedure Cls (Col : Byte; Where:word);
 Procedure Cls2 (Where:word);
 procedure flip(src,dst,offs:word);
 procedure putsprite(x,y,spriteseg,spriteoff,zielseg,xsize,ysize:word);
 procedure puttile(x,y,spriteseg,spriteoff,zielseg,xsize,ysize:word);
 Procedure LoadCEL (FileName :  string; ScrPtr : pointer);
 Procedure LoadCELpic (FileName :  string;where:pointer);
 Procedure LoadPAL (FileName :  string);
 procedure starttime;
 procedure endtime;
 function  tan(winkel : real) : real;
 procedure getpalette(var pal : palettetyp);
 procedure setpalette(pal : palettetyp);
 procedure inten(pal : palettetyp);

IMPLEMENTATION

USES DOS,CRT;

(*_____________________________________________________________________________*)
procedure Vertline(x,entf,where:word;color:byte);assembler;
asm
    mov ax, where
    mov es, ax      {es = wohin ?}
    mov ax, 20000
    div entf
    mov cx, ax      {cx = lnge = 20000 div entfernung}
    cmp cx, 200
    jbe @laengekleiner200
    mov cx, 200
    @laengekleiner200:
    mov dx, cx;
    shr cx, 1       {cx = L/2}
    mov bx, 100
    sub bx, cx      {bx = 100 - L/2 -> AnfangsY}
    xor al, al
    mov ah, bl      {ax = AnfangsY shl 8}
    shl bx, 6
    add ax, bx      {ax = y shl 8 + y shl 6 => ax = AnfangsY * 320}
    mov di, x
    add di, ax      {es:di zeigt auf X,AnfangsY}
    mov cx, dx      {cx = pixelcounter}
    mov al, color   {al = color}
    @nochnpixel:
    mov [es:di], al {punkt setzen}
    dec cx
    add di, 320
    cmp cx, 0
    jne @nochnpixel
end;
(*_____________________________________________________________________________*)
Procedure Putpixel (X,Y : word; Col : Byte; where : word);assembler;
{ V 1.0 - 1000*1000 Pixel -> 341 ms. 486}
{ V 2.0 - 1000*1000 Pixel -> 330 ms. 486}
{ V 2.0 - 1000*1000 Pixel -> 110 ms. 586}
{ V 3.0 - 1000*1000 Pixel -> 109 ms. 586}
Asm
    mov     es, where  {3}
    mov     di, x      {1}
    mov     bx, y      {1}
    xor     dl, dl     {1}            { dx:= bx shl 8}
    mov     dh, bl     {1}            {      -"-     }
    shl     bx, 6      {3}            { 6            }
    add     dx, bx     {1}            { dx = dx + bx (ie y*320)}
    add     di, dx     {1}            { finalise location}
    mov     al, Col    {1}
    mov     [es:di],al {1}
end;
(*_____________________________________________________________________________*)
Procedure SetPal(Col,R,G,B : Byte);assembler;
{ This sets the Red, Green and Blue values of a certain color }
asm
   mov    dx,3c8h
   mov    al,[col]
   out    dx,al
   inc    dx
   mov    al,[r]
   out    dx,al
   mov    al,[g]
   out    dx,al
   mov    al,[b]
   out    dx,al
end;
(*_____________________________________________________________________________*)
Procedure GetPal(Col : Byte; Var R,G,B : Byte);
{ This gets the Red, Green and Blue values of a certain color }
Var
   rr,gg,bb : Byte;
Begin
   asm
      mov    dx,3c7h
      mov    al,[col]
      out    dx,al
      add    dx,2
      in     al,dx
      mov    [rr],al
      in     al,dx
      mov    [gg],al
      in     al,dx
      mov    [bb],al
   end;
   r := rr;
   g := gg;
   b := bb;
end;
(*_____________________________________________________________________________*)
procedure WaitRetrace; assembler;
{  This waits for a vertical retrace to reduce snow on the screen }
label
  l1, l2;
asm
    mov dx,3DAh
l1:
    in al,dx
    and al,08h
    jnz l1
l2:
    in al,dx
    and al,08h
    jz  l2
end;
(*_____________________________________________________________________________*)
Procedure SetMCGA;
{ This procedure gets you into 320x200x256 mode. }
BEGIN
  asm
     mov        ax,0013h
     int        10h
  end;
END;
(*_____________________________________________________________________________*)
Procedure SetText;
{ This procedure returns you to text mode.  }
BEGIN
  asm
     mov        ax,0003h
     int        10h
  end;
END;
(*_____________________________________________________________________________*)
Procedure Cls (Col : Byte; Where:word);assembler;
{ This clears the screen to the specified color }
asm
  mov     cx, 16000;
  mov     es,where
  db      66h
  xor     ax,ax
  xor     di,di
  db      66h
  rep     stosw
End;
(*_____________________________________________________________________________*)
Procedure Cls2 (Where:word);assembler;
{ This clears the screen to the specified color }
asm
  mov     cx, 14320;
  mov     es,where
  db      66h
  xor     ax,ax
  xor     di,di
  db      66h
  rep     stosw
End;
(*_____________________________________________________________________________*)
procedure flip(src,dst,offs:word); assembler;
asm
  mov ax, ds
  mov ds, src
  mov si, offs
  mov es, dst
  xor di, di
  mov cx, 16000
  db  66h
  rep movsw
  mov ds, ax
end;
(*_____________________________________________________________________________*)
procedure putsprite(x,y,spriteseg,spriteoff,zielseg,xsize,ysize:word); assembler;
asm

  push ds

  mov ds,spriteseg
  mov es,zielseg


  mov  ax, y     { AX = Y_Position }
  mov  dx, ax    { DX = Y_Position }

  mov  dh,dl
  xor  dl,dl     { DX = Y_Position * 256 }

  shl  ax, 1
  shl  ax, 1
  shl  ax, 1
  shl  ax, 1
  shl  ax, 1
  shl  ax, 1     { AX = Y_Position * 64 }

  add  dx, ax    { DX = Y_Position * 320 }

  add  dx, x     { DX = Y_Position * 320 + X_Position }

  mov di,dx        { DI linker,oberer Punkt des Sprites im Zieloffset }

  mov si,spriteoff { SI zeigt auf Spriteoffset }

  mov bx,xsize   { BX auf Spaltenzhler }
  mov cx,ysize   { CX auf Zeilenzhler  }

  jmp @nextpunkt

  { vor Nextzeile :

  AX =

  BX = Anzahl Spalten

  CX = Anzahl Zeilen

  DX = Y_Position * 320 + X_Position


  DS:SI = Spritesegment : Spriteoffset

  ES:DI = linker,oberer Punkt des Sprites im Zieloffset
  }

@nextzeile :

  add dx,320     { DX = Y_Position von nchster Zeile }
  mov di,dx
  mov bx,xsize   { BX auf Spaltenzhler }

@nextpunkt :

  mov al,[ds:si]
  inc si          { al = nchster Spritepunkt }

  or al,al
  jz @skip       { hat der Punkt Color 0 ? jepp -> @skip }

  mov [es:di],al { Punkt setzen }

@skip :

  inc di
  dec bx
  or  bx,bx
  jnz @nextpunkt

  dec cx         {Zeilenzhler dekrementieren}
  or  cx,cx
  jnz @nextzeile {Wenn noch Zeilen abzuarbeiten sind -> @nextzeile }

  pop ds
end;
(*_____________________________________________________________________________*)
procedure puttile(x,y,spriteseg,spriteoff,zielseg,xsize,ysize:word); assembler;
asm

  push ds

  mov ds,spriteseg
  mov es,zielseg


  mov  ax, y     { AX = Y_Position }
  mov  dx, ax    { DX = Y_Position }

  mov  dh,dl
  xor  dl,dl     { DX = Y_Position * 256 }

  shl  ax, 1
  shl  ax, 1
  shl  ax, 1
  shl  ax, 1
  shl  ax, 1
  shl  ax, 1     { AX = Y_Position * 64 }

  add  dx, ax    { DX = Y_Position * 320 }

  add  dx, x     { DX = Y_Position * 320 + X_Position }

  mov di,dx        { DI linker,oberer Punkt des Sprites im Zieloffset }

  mov si,spriteoff { SI zeigt auf Spriteoffset }

  mov bx,xsize   { BX auf Spaltenzhler }
  mov cx,ysize   { CX auf Zeilenzhler  }

  jmp @nextpunkt

  { vor Nextzeile :

  AX =

  BX = Anzahl Spalten

  CX = Anzahl Zeilen

  DX = Y_Position * 320 + X_Position


  DS:SI = Spritesegment : Spriteoffset

  ES:DI = linker,oberer Punkt des Sprites im Zieloffset
  }

@nextzeile :

  add dx,320     { DX = Y_Position von nchster Zeile }
  mov di,dx
  mov bx,xsize   { BX auf Spaltenzhler }

@nextpunkt :

  mov al,[ds:si]
  inc si          { al = nchster Spritepunkt }
  mov [es:di],al { Punkt setzen }
  inc di
  dec bx
  or  bx,bx
  jnz @nextpunkt

  dec cx         {Zeilenzhler dekrementieren}
  or  cx,cx
  jnz @nextzeile {Wenn noch Zeilen abzuarbeiten sind -> @nextzeile }

  pop ds
end;
(*_____________________________________________________________________________*)
Procedure LoadCEL (FileName :  string; ScrPtr : pointer);
var
  Fil : file;
  Buf : array [1..1024] of byte;
  BlocksRead, Count : word;
begin
  {$I-}
  assign (Fil, FileName);
  reset (Fil, 1);
  BlockRead (Fil, Buf, 800);       {Read and ignore the 800 byte header}
  Count := 0; BlocksRead := $FFFF;
  while (not eof (Fil)) and (BlocksRead <> 0) do begin
    BlockRead (Fil, mem [seg(ScrPtr^):ofs(ScrPtr^)+Count], 1024, BlocksRead);
    Count := Count + 1024;
  end;
  close (Fil);
  {$I+}
end;
(*_____________________________________________________________________________*)
Procedure LoadCELpic (FileName :  string;where:pointer);
var
  Fil : file;
  BlocksRead, Count : word;
begin
  {$I-}
  assign (Fil, FileName);
  reset (Fil,1);

  seek(Fil,800);       {Read and ignore the 800 byte header}

  BlocksRead := $FFFF;
  BlockRead (Fil, mem[seg(where^):ofs(where^)], 64000, BlocksRead);
  close (Fil);
  {$I+}
end;
(*_____________________________________________________________________________*)
Procedure LoadPAL (FileName :  string);
var
  Fil    : file of byte;
  farbnr : byte;
  r,b,g  : byte;
begin
  {$I-}
  assign (Fil, FileName);
  reset (Fil);
  for farbnr := 0 to 255 do
  begin
  read(fil,r);
  read(fil,g);
  read(fil,b);
  setpal(farbnr,r,g,b);
  end;
  close (Fil);
  {$I+}
end;
(*_____________________________________________________________________________*)
 procedure starttime;
 begin
  gettime(hr,m,s,h);
 end;
(*_____________________________________________________________________________*)
procedure endtime;
  begin
    gettime(hr2,m2,s2,h2);
    mili1:=h+100*s+60*100*m+60*60*100*hr;
    mili2:=h2+100*s2+60*100*m2+60*60*100*hr2;
    mili3:=mili2-mili1;
    settext;
    textcolor(lightgray);
    textbackground(black);
    writeln('BEARBEITUNGSZEIT : ',mili3,' ms.');
    writeln;
    writeln('Fr 50 Frames bedeutet das : ',mili3/50 :2:2,' ms. / Frame ');
    writeln;
    writeln('Frames / s. : ',100/(mili3/50) :6:2);
    writeln;
    write('Bewertung : ');
    case trunc(100/(mili3/50)) of
                        0..5 : writeln(':-(');
                        5..15 : writeln(':-|');
                        15..25 : writeln(':-)');
                        25..100 : writeln('>;->');
    end;
    readkey;
  end;
(*_____________________________________________________________________________*)
 function  tan(winkel : real):real;
 begin
 tan := sin(winkel) / cos(winkel);
 end;
(*_____________________________________________________________________________*)
 procedure getpalette(var pal : palettetyp);
 var lauf : byte;
 begin
 for lauf:= 0 to 255 do
  with pal[lauf] do getpal(lauf,r,g,b);
 end;
(*_____________________________________________________________________________*)
 procedure setpalette(pal : palettetyp);
 var lauf : byte;
 begin
 for lauf:= 0 to 255 do
  with pal[lauf] do setpal(lauf,r,g,b);
 end;
(*_____________________________________________________________________________*)
 procedure inten(pal : palettetyp);
 var lauf  : byte;
     r,g,b : byte;
 begin
 if delta > 63 then delta := 63;
 if delta <-63 then delta := -63;

 if delta >= 0 then
 for lauf:= 1 to 255 do
   begin
     r:= pal[lauf].r;
     g:= pal[lauf].g;
     b:= pal[lauf].b;
     if (r < 63-delta) then inc(r,delta) else r := 63;
     if (g < 63-delta) then inc(g,delta) else g := 63;
     if (b < 63-delta) then inc(b,delta) else b := 63;
   setpal(lauf,r,g,b);
   end;

 if delta < 0 then
 for lauf:= 1 to 255 do
   begin
     r:= pal[lauf].r;
     g:= pal[lauf].g;
     b:= pal[lauf].b;
     if r > abs(delta) then inc(r,delta) else r := 0;
     if g > abs(delta) then inc(g,delta) else g := 0;
     if b > abs(delta) then inc(b,delta) else b := 0;
   setpal(lauf,r,g,b);
   end;


 end;
END.