{****************************************************************************}
{                                                                            }
{ Name        : Triplanes                                                    }
{                                                                            }
{ Author      : Andreas Schrger                                             }
{                                                                            }
{ Version     : 0.10                                                         }
{                                                                            }
{ Date        : 1.11.99                                                      }
{                                                                            }
{ Ver.Info    : - Flieger knnen abgeschossen werden , strzen ab            }
{               - Gegner strzt nicht absichtlich ab :-)                     }
{               - Camels als Gegner                                          }
{               - Zwei Spieler                                               }
{               - Neu formatiert                                             }
{               - neue Ausweichroutine (Boden) f. Computerflieger            }
{               - Zahlendarstellung                                          }
{               - mit Setupprogramm                                          }
{                                                                            }
{****************************************************************************}

{$X+}
program cccptest;

uses crt,dos,cccpvga,cccpkeyb2;

const wendigkeit=10;                        {Wendigkeit der fliegers}
      mgspeed=5;                            {Geschwindigkeit der MG-Geschosse}
      timetest=false;
      snd=false;
      sb=2;
      schussschaden=true;

Type spritetyp =Record
                 shotdelay:byte;            { delay fr schsse           }
                 wendedelay:byte;
                 typ:byte;                  { Was ist das Sprite ?        }
                 aktiv:boolean;             { Gibt's das Sprite berhaupt }
                 x,y:word;                  { aktuelle x & y Koordinaten  }
                 richtung:byte;
                 speed:byte;                { aktuelle Geschwindigkeit    }
                 zustand:byte;              { Zustand des Sprites         }
                 breite,hoehe:byte;         { Breite & Hhe               }
                 del:byte;                  { Delay fr langsame Bewegung }
                 hitpoints:byte;            { Hitpoints :)                }
                END;

     zahlsprite = array[0..5,0..7] of byte;


{ TYP : 1-Fokker 2-Wolke 3-Explosion 4-Britte 5-sterbender Britte 6-Schuss
        7-MG-Einschlag 8-player:fokker 9-Camel 10-player2:camel}

     VirtPtr    = ^vgascreen;               { Pointer -> Virtual screen  }

var screen,background : virtptr;            { Screen & Back Grafik       }
    scraddr,backaddr  : word;

    xver              : word;               { Screen & Back Adressen     }

    fokzahl           : byte;               {Anzahl der Fokkers}
    camelzahl         : byte;               {Anzahl der Anzahl der Camels}
    wolkenzahl        : byte;               {Anzahl der Wolken }
    brittenzahl       : byte;               {Anzahl der Britten ...}
    Player1da         : byte;
    Player2da         : byte;
    hitp              : byte;               { Hitpoints pro Flieger }


    wendedelay        : byte;               { Delay:Wendigkeit d. PlayerSprite}

    wendedelay2       : byte;               { Delay:Wendigkeit d.2PlayerSprite}


    player1,player2   : word;               {Objektnummer Player 1/2 }

    zahlspr           : array[0..9] of zahlsprite;
    fokkersprites     : array[1..11] of pointer; { Pointer fr Grafiken }
    camelsprites      : array[1..11] of pointer;
    wolke             : array[1..5] of pointer;
    explosion         : array[1..7] of pointer;
    Britte            : array[1..6] of pointer;
    Brittetot         : array[1..5] of pointer;
    einschlag         : array[1..5] of pointer;
    krater            : pointer;

    Objekte           : array[1..3000] of spritetyp; { Die Objekte ... }

    obzahl            : word;
    ch                : char;

{*****************************************************************************}
{-----------------------------------------------------------------------------}
Procedure Loadvars (FileName :  string);
var
  Fil : file;
  Buf : array [1..1024] of byte;
  BlocksRead : word;
begin
  {$I-}

{
 0=keiner 1=rot 2=grn

 1 : fokkerzahl
 2 : camelzahl
 3 : Brittenzahl
 4 : Wolkenzahl
 5 : Player1 0/1/2
 6 : Player2 0/1/2
}

  assign (Fil, FileName);
  reset (Fil, 1);

  BlockRead (Fil, fokzahl  ,   1, BlocksRead);
  BlockRead (Fil, camelzahl,   1, BlocksRead);
  BlockRead (Fil, brittenzahl, 1, BlocksRead);
  BlockRead (Fil, wolkenzahl,  1, BlocksRead);
  BlockRead (Fil, player1da,   1, BlocksRead);
  BlockRead (Fil, player2da,   1, BlocksRead);
  BlockRead (Fil, hitp,        1, BlocksRead);

  close (Fil);
  {$I+}
end;
{-----------------------------------------------------------------------------}
procedure delobjekt(num:word);   {Lscht angegebenes Objekt}
var lauf : word;                 {Verteilt restliche Obj. neu}

begin
 with objekte[num] do
 begin
  x:=0;y:=0;speed:=0;richtung:=0;typ:=0;zustand:=0;breite:=0;hoehe:=0;aktiv:=false;del:=0;
  shotdelay:=0;
 end;

 for lauf := num to obzahl do
 begin
 objekte[lauf]:=objekte[lauf+1]; {objekte nachrcken}
 end;

 with objekte[obzahl] do
 begin
  x:=0;y:=0;speed:=0;richtung:=0;typ:=0;zustand:=0;breite:=0;hoehe:=0;aktiv:=false;del:=0;
  shotdelay:=0;
 end;

 dec(obzahl);

end;
{-----------------------------------------------------------------------------}
function neuobjekt:word;                {Findet erstes,freies Objekt}
var lauf : word;

begin
 lauf:=0;

 if not objekte[lauf].aktiv then
  repeat
  inc(lauf);
  until not objekte[lauf].aktiv;

 with objekte[lauf] do
  begin
   x:=0;y:=0;speed:=0;richtung:=0;typ:=0;zustand:=0;breite:=0;hoehe:=0;aktiv:=false;del:=0;
   shotdelay:=0;
  end;

 obzahl:=lauf;
 neuobjekt:=lauf;

end;
{-----------------------------------------------------------------------------}
procedure init;                          {Initialisiert Triplanes ...}
var lauf : word;
    objektnummer:word;
    buffer:spritetyp;
begin
randomize;setmcga;             { Zufallszahlen & MCGA setzen               }

{$I-}

loadpal('titel.COL');           { Palette "titel.col" laden          }
loadCELpic('titel.cel',ptr(vga,0));    { "titel.cel" in VGA-Speicher laden   }

delay(1000);                    {Delay damit ctrl-taste beim ctrl-f9 losgelassen ist}

loadvars('triplane.cfg');


GetMem (Screen,64000);         { Speicher fr Screen-Pointer reservieren   }
GetMem (background,64000);     { Speicher fr Backgrnd-Pointer reservieren }
Scraddr := seg (screen^);      { Adresse von Screen-Speicher feststellen   }
backaddr := seg (background^); { Adresse von Backgrnd-Speicher feststellen }

for lauf := 1 to 3000 do       {ALLE Objekte Lschen}
with objekte[lauf] do
 begin
  x:=0;y:=0;speed:=0;richtung:=0;typ:=0;zustand:=0;breite:=0;hoehe:=0;aktiv:=false;del:=0;
 end;

for lauf := 1 to 11 do
 GetMem(fokkersprites[lauf],16*16);           { Speicher fr Fokker reservieren }

Loadcel('Fok1_1.CEL',Fokkersprites[1]);  { "flieger.cel" in sprite laden   }
Loadcel('Fok1_2.CEL',Fokkersprites[2]);  { "flieger.cel" in sprite laden   }
Loadcel('Fok1_3.CEL',Fokkersprites[3]);  { "flieger.cel" in sprite laden   }
Loadcel('Fok1_4.CEL',Fokkersprites[4]);  { "flieger.cel" in sprite laden   }
Loadcel('Fok1_5.CEL',Fokkersprites[5]);  { "flieger.cel" in sprite laden   }
Loadcel('Fok1_6.CEL',Fokkersprites[6]);  { "flieger.cel" in sprite laden   }
Loadcel('Fok1_7.CEL',Fokkersprites[7]);  { "flieger.cel" in sprite laden   }
Loadcel('Fok1_8.CEL',Fokkersprites[8]);  { "flieger.cel" in sprite laden   }
Loadcel('Fok1Down.CEL',Fokkersprites[9]);  { "flieger.cel" in sprite laden   }
Loadcel('Fok2Down.CEL',Fokkersprites[10]);  { "flieger.cel" in sprite laden   }
Loadcel('Fok3Down.CEL',Fokkersprites[11]);  { "flieger.cel" in sprite laden   }

for lauf := 1 to 11 do
 GetMem(camelsprites[lauf],16*16);           { Speicher fr Fokker reservieren }

Loadcel('camel1_1.CEL',camelsprites[1]);  { "flieger.cel" in sprite laden   }
Loadcel('camel1_2.CEL',camelsprites[2]);  { "flieger.cel" in sprite laden   }
Loadcel('camel1_3.CEL',camelsprites[3]);  { "flieger.cel" in sprite laden   }
Loadcel('camel1_4.CEL',camelsprites[4]);  { "flieger.cel" in sprite laden   }
Loadcel('camel1_5.CEL',camelsprites[5]);  { "flieger.cel" in sprite laden   }
Loadcel('camel1_6.CEL',camelsprites[6]);  { "flieger.cel" in sprite laden   }
Loadcel('camel1_7.CEL',camelsprites[7]);  { "flieger.cel" in sprite laden   }
Loadcel('camel1_8.CEL',camelsprites[8]);  { "flieger.cel" in sprite laden   }

Loadcel('cam2Down.CEL',camelsprites[9]);  { "flieger.cel" in sprite laden   }
Loadcel('cam2Down.CEL',camelsprites[10]);  { "flieger.cel" in sprite laden   }
Loadcel('cam2Down.CEL',camelsprites[11]);  { "flieger.cel" in sprite laden   }

for lauf := 1 to 5 do
 GetMem(wolke[lauf],85*35);            {Speicher fr Wolken reservieren}

Loadcel('Wolke1.CEL',wolke[1]);       {Wolke laden}
loadcel('Wolke2.CEL',wolke[2]);       {Wolke laden}
Loadcel('Wolke3.CEL',wolke[3]);       {Wolke laden}
Loadcel('Wolke4.CEL',wolke[4]);       {Wolke laden}
Loadcel('Wolke5.CEL',wolke[5]);       {Wolke laden}

for lauf := 1 to 7 do
 GetMem(explosion[lauf],16*16);        {Speicher fr Explosionen reservieren}

Loadcel('Ex1_1.CEL',explosion[1]);    {Wolke laden}
Loadcel('Ex1_2.CEL',explosion[2]);    {Wolke laden}
Loadcel('Ex1_3.CEL',explosion[3]);    {Wolke laden}
Loadcel('Ex1_4.CEL',explosion[4]);    {Wolke laden}
Loadcel('Ex1_5.CEL',explosion[5]);    {Wolke laden}
Loadcel('Ex1_6.CEL',explosion[6]);    {Wolke laden}
Loadcel('Ex1_7.CEL',explosion[7]);    {Wolke laden}

for lauf := 1 to 6 do
 GetMem(britte[lauf],8*8);            {Speicher fr Britten reservieren}

Loadcel('man1_1.CEL',britte[1]);     {britte laden}
Loadcel('man1_2.CEL',britte[2]);     {britte laden}
Loadcel('man1_3.CEL',britte[3]);     {britte laden}
Loadcel('man1_4.CEL',britte[4]);     {britte laden}
Loadcel('man1_5.CEL',britte[5]);     {britte laden}
Loadcel('man1_6.CEL',britte[6]);     {britte laden}

for lauf := 1 to 6 do
 GetMem(brittetot[lauf],16*8);            {Speicher fr tote Britten reservieren}

Loadcel('mand1_1.CEL',brittetot[1]);     {britte laden}
Loadcel('mand1_2.CEL',brittetot[2]);     {britte laden}
Loadcel('mand1_3.CEL',brittetot[3]);     {britte laden}
Loadcel('mand1_4.CEL',brittetot[4]);     {britte laden}
Loadcel('mand1_5.CEL',brittetot[5]);     {britte laden}

getmem(krater,3*12);

Loadcel('krater.cel',krater);     {krater laden}

for lauf := 1 to 5 do
GetMem(einschlag[lauf],6*6);        {Speicher fr MG-Einschlge reservieren}
Loadcel('Ex2_1.CEL',einschlag[1]);  {Einschlag laden}
Loadcel('Ex2_2.CEL',einschlag[2]);  {Einschlag laden}
Loadcel('Ex2_3.CEL',einschlag[3]);  {Einschlag laden}
Loadcel('Ex2_4.CEL',einschlag[4]);  {Einschlag laden}
Loadcel('Ex2_5.CEL',einschlag[5]);  {Einschlag laden}


ch := '0';
for lauf := 0 to 9 do begin         {Zahlen laden}
 loadcel(ch+'.cel',ptr(seg(zahlspr[lauf]),ofs(zahlspr[lauf])));
 inc(ch);
end;


for lauf := 1 to wolkenzahl do  {Random-Wolken generieren}
begin
 objektnummer:=neuobjekt;
 with objekte[objektnummer] do
  begin
   x:=random(300);
   y:=random(135);
   zustand:=random(4)+1;
   richtung:=1;
   speed:=126-random(3);
   typ:=2;
   hoehe:=35;
   breite:=85;
   aktiv:=true;
  end;
end;

for lauf := 1 to brittenzahl do {Random-Britten generieren}
begin
 objektnummer:=neuobjekt;
 with objekte[objektnummer] do
  begin
   x:=random(300);
   y:=192-random(27);
   zustand:=random(5)+1;
   richtung:=5;
   speed:=126-random(3);
   typ:=4;
   hoehe:=8;
   breite:=8;
   aktiv:=true;
   hitpoints := 1;
 end;
end;

for lauf := 1 to fokzahl do {Random-Fokkers generieren}
begin
 objektnummer:=neuobjekt;
 with objekte[objektnummer] do
  begin
   x:=random(300);
   y:=random(160);
   richtung:=random(7)+1;
   zustand:=richtung;
   speed:=127+random(2);                 {128=1 pixel/frame}
   typ:=1;
   hoehe:=16;
   breite:=16;
   aktiv:=true;
   hitpoints:=hitp;
   shotdelay:=10;
 end;
end;

for lauf := 1 to camelzahl do {Random-Camels generieren}
begin
 objektnummer:=neuobjekt;
 with objekte[objektnummer] do
  begin
   x:=random(300);
   y:=random(160);
   richtung:=random(7)+1;
   zustand:=richtung;
   speed:=127+random(2);                 {128=1 pixel/frame}
   typ:=9;
   hoehe:=16;
   breite:=16;
   aktiv:=true;
   hitpoints:=hitp;
   shotdelay:=10;
  end;
end;


if player1da=1 then
begin
objektnummer:=neuobjekt;           {Fokker:Spieler}
player1:=objektnummer;
with objekte[objektnummer] do
 begin
  x:=random(300);
  y:=random(140)+20;
  richtung:=1;
  zustand:=richtung;
  speed:=128;                 {128=1 pixel/frame}
  typ:=8;
  hoehe:=16;
  breite:=16;
  aktiv:=true;
  hitpoints:=hitp;
 end;
end;

if player2da=1 then
begin
objektnummer:=neuobjekt;           {camel:Spieler2}
player2:=objektnummer;
with objekte[objektnummer] do
 begin
  x:=random(300);
  y:=random(140)+20;
  richtung:=5;
  zustand:=richtung;
  speed:=128;                 {128=1 pixel/frame}
  typ:=10;
  hoehe:=16;
  breite:=16;
  aktiv:=true;
  hitpoints:=hitp;
 end;
end;


cls(0,vga);
loadpal('cccp3.col');                   { Palette "CCCP.COL" laden           }
loadCELpic('terain.CEL',ptr(backaddr,0));    { "landsch.cel" in hintergrund laden }
flip(backaddr,scraddr,0);              { Hintergrund auf den Screen         }
flip(scraddr,vga,0);                  { Hintergrund auf den Bildschirm     }

{$I+}

if ioresult <> 0 then begin sound(200);delay(100);nosound;
settext;clrscr;write('Datei(en) nicht gefunden');halt;end;

install; {Tastaturhandler}

end;
{-----------------------------------------------------------------------------}
procedure clearup;
var lauf:word;
begin


uninstall; {Tastaturhandler}


freeMem (Screen,64000);         { Speicher fr Screen-Pointer freigeben   }
freeMem (background,64000);     { Speicher fr Backgrnd-Pointer freigeben }

for lauf := 1 to 11 do
 freeMem(fokkersprites[lauf],16*16);   { Speicher fr Fokker freigeben }

for lauf := 1 to 11 do
 freeMem(camelsprites[lauf],16*16);    { Speicher fr Camel freigeben }

for lauf := 1 to 5 do
 freeMem(wolke[lauf],85*35);           { Speicher fr Wolken freigeben }

for lauf := 1 to 7 do
 freeMem(explosion[lauf],16*16);            {Speicher fr Wolken freigeben}

for lauf := 1 to 6 do
 freeMem(britte[lauf],8*8);            {Speicher fr Britten freigeben}

freeMem(krater,3*12);

for lauf := 1 to 6 do
 freeMem(brittetot[lauf],16*8);            {Speicher fr tote Britten freigeben}

for lauf := 1 to 5 do
 freeMem(einschlag[lauf],6*6);        {Speicher fr Explosionen freigeben}

settext;clrscr;                      { Textmodus & CLRSCR }

for lauf := obzahl+1 to 3000 do if objekte[lauf].aktiv then
begin
 sound(200);delay(100);nosound;writeln('Defekt : ',lauf);readln;
end;

end;
{-----------------------------------------------------------------------------}
procedure neu_explosion(xpos,ypos:word);
var objektnr : word;
 begin
  objektnr:=neuobjekt;
  with objekte[objektnr] do
   begin
    x:=xpos-8;
    y:=ypos-8;
    zustand:=1;
    typ:=3;
    hoehe:=16;
    breite:=16;
    aktiv:=true;
   end;

for objektnr := 1 to obzahl do
 with objekte[objektnr] do
  begin
   if typ in [4] then
   if x > xpos-8 then
   if x < xpos+16 then
   if y > ypos-8 then
   if y < ypos+16 then
    if hitpoints > 5 then dec(hitpoints,2)
     else hitpoints:=0;
  end;
end;

{-----------------------------------------------------------------------------}
procedure neu_einschlag(xpos,ypos:word);
var objektnr : word;
begin
 objektnr:=neuobjekt;
 with objekte[objektnr] do
  begin
  x:=xpos-3;
  y:=ypos-6;
  zustand:=1;
  typ:=7;
  hoehe:=6;
  breite:=6;
 aktiv:=true;
end;
end;

{-----------------------------------------------------------------------------}
procedure bewegung(num:word;pixel:byte);
begin
with objekte[num]do
begin

case richtung of

 1 : begin
     inc(x,pixel);
     end;
 2 : begin
     inc(x,pixel);
     dec(y,pixel);
     end;
 3 : begin
     dec(y,pixel);
     end;
 4 : begin
     dec(x,pixel);
     dec(y,pixel);
     end;
 5 : begin
     dec(x,pixel);
     end;
 6 : begin
     dec(x,pixel);
     inc(y,pixel);
     end;
 7 : begin
     inc(y,pixel);
     end;
 8 : begin
     inc(x,pixel);
     inc(y,pixel);
     end;
 end;
end;
end;
{-----------------------------------------------------------------------------}
PROCEDURE zahlshow(zahl,x,y:word);
var zahlx,zahly : word;
BEGIN

if zahl > 999 then zahl := 999;

zahly:=zahl;
if zahl<100 then zahlx := 0;if zahl>=100 then zahlx := 1;if zahl>=200 then zahlx := 2;
if zahl>=300 then zahlx := 3;if zahl>=400 then zahlx := 4;if zahl>=500 then zahlx := 5;
if zahl>=600 then zahlx := 6;if zahl>=700 then zahlx := 7;if zahl>=800 then zahlx := 8;
if zahl>=900 then zahlx := 9;

putsprite(x,y,seg(zahlspr[zahlx]),ofs(zahlspr[zahlx]),scraddr,6,8);

zahl := zahl-(zahlx*100);

if zahl<10 then zahlx := 0;if zahl>=10 then zahlx := 1;if zahl>=20 then zahlx := 2;
if zahl>=30 then zahlx := 3;if zahl>=40 then zahlx := 4;if zahl>=50 then zahlx := 5;
if zahl>=60 then zahlx := 6;if zahl>=70 then zahlx := 7;if zahl>=80 then zahlx := 8;
if zahl>=90 then zahlx := 9;

putsprite(x+6,y,seg(zahlspr[zahlx]),ofs(zahlspr[zahlx]),scraddr,6,8);

zahl := zahl-(zahlx*10);

if zahl<1 then zahlx := 0;if zahl>=1 then zahlx := 1;if zahl>=2 then zahlx := 2;
if zahl>=3 then zahlx := 3;if zahl>=4 then zahlx := 4;if zahl>=5 then zahlx := 5;
if zahl>=6 then zahlx := 6;if zahl>=7 then zahlx := 7;if zahl>=8 then zahlx := 8;
if zahl>=9 then zahlx := 9;

putsprite(x+12,y,seg(zahlspr[zahlx]),ofs(zahlspr[zahlx]),scraddr,6,8);

end;
{-----------------------------------------------------------------------------}
procedure neu_shot(anfang:word);
var objektnr : word;
    xpos,ypos: word;
    richt    : byte;
begin

with objekte[anfang] do
begin
case richtung of
 1 : begin xpos:=x+15;ypos:=y+5;end;
 2 : begin xpos:=x+10;ypos:=y+3;end;
 3 : begin xpos:=x+6;ypos:=y+1;end;
 4 : begin xpos:=x+3;ypos:=y+6;end;
 5 : begin xpos:=x;ypos:=y+9;end;
 6 : begin xpos:=x+6;ypos:=y+11;end;
 7 : begin xpos:=x+11;ypos:=y+14;end;
 8 : begin xpos:=x+12;ypos:=y+8;end;
end;
richt:=richtung;
end;

objektnr:=neuobjekt;
with objekte[objektnr] do
 begin
  x:=xpos;
  y:=ypos;
  typ:=6;
  aktiv:=true;
  speed:=128+mgspeed;
  richtung:=richt;
  zustand:=1;
  hoehe:=16;
  breite:=16;
 end;
bewegung(objektnr,5);  {damit man sich nicht selber abschiesst :-) }
end;
{-----------------------------------------------------------------------------}
procedure bewegen;
var lauf   : word;
    pixel  : byte;
begin
 for  lauf:= 1 to obzahl do
 with objekte[lauf] do
 if aktiv then
 if speed > 0 then
 begin
  if speed >= 128 then pixel := speed-127;
  if speed < 128 then
  begin
  pixel:=0;
  inc(del);
  if del = 128-speed then
   begin
   pixel:=1;
   del:=0;
   end;
  end;
  bewegung(lauf,pixel);
 end;
end;
{-----------------------------------------------------------------------------}
procedure anzeigen;
var lauf : word;
    segment,ofset : word;
begin
 for lauf := 1 to obzahl do
 with objekte[lauf] do

 if aktiv then

 begin
  case typ of
   1,8 : begin
       segment:=seg(fokkersprites[zustand]^);
       ofset:=ofs(fokkersprites[zustand]^);
       end;
   2 : begin
       segment:=seg(wolke[zustand]^);
       ofset:=ofs(wolke[zustand]^);
       end;
   3 : begin
       segment:=seg(explosion[zustand]^);
       ofset:=ofs(explosion[zustand]^);
       end;
   4 : begin
       segment:=seg(britte[zustand]^);
       ofset:=ofs(britte[zustand]^);
       end;
   5 : begin
       segment:=seg(brittetot[zustand]^);
       ofset:=ofs(brittetot[zustand]^);
       end;
   7 : begin
       segment:=seg(einschlag[zustand]^);
       ofset:=ofs(einschlag[zustand]^);
       end;
   9,10 : begin
       segment:=seg(camelsprites[zustand]^);
       ofset:=ofs(camelsprites[zustand]^);
       end;

{ TYP : 1-Fokker 2-Wolke 3-Explosion 4-Britte 5-sterbender Britte 6-Schuss
        7-MG-Einschlag 8-player fokker 9-camel 10-player2 camel}

  end;

 if typ <> 6 then putsprite(x,y,segment,ofset,scraddr,breite,hoehe)

 else if (x < 320) and (y < 200 ) then putpixel(x,y,62,scraddr);


 if player2da=1 then
 begin
  zahlshow(objekte[player2].hitpoints,20,189);
  putsprite(1,184,seg(camelsprites[1]^),ofs(camelsprites[1]^),scraddr,16,16);
 end;

 if player1da=1 then
 begin
  zahlshow(objekte[player1].hitpoints,300,189);
  putsprite(280,184,seg(fokkersprites[1]^),ofs(fokkersprites[1]^),scraddr,16,16);
 end;

 end;
 waitretrace;
 flip(scraddr,vga,0);                  { screen auf Bildschirm kopieren }
end;
{-----------------------------------------------------------------------------}
procedure scr_leeren;
begin
{xver:=(xver+1) mod 320;               { Landschaft verschieben         }
flip(backaddr,scraddr,xver);           { Screen mit Hintergrund fllen  }
{cls(2,scraddr);                       { Clearscreen                    }
end;                                   { 77  ohne 99  cls 104 back      }


{-----------------------------------------------------------------------------}
procedure ki_flieger(objnummer:word);  {Steuert Computerflieger}
var zufall : byte;
begin
 with objekte[objnummer] do begin
    if wendedelay > 0 then dec(wendedelay);
    if wendedelay=0 then
      begin
       wendedelay:=wendigkeit;
       if (y > 24) and (y < 161) then    {wenn der Flieger nicht in Kollisionsgefahr ist}
       begin
        zufall:=random(255);
        if zufall  < 100   then dec(richtung);
        if zufall  > 150 then inc(richtung);
        if richtung = 0   then richtung := 8;
        if richtung = 9   then richtung := 1;
       end;

       {nicht oben rausfliegen}
       if y < 25 then if richtung = 3 then if random(10) < 5
                                           then richtung := 2
                                           else richtung := 4;

         if y < 15 then if richtung = 1 then richtung  := 8;
         if y < 15 then if richtung = 5 then richtung  := 6;
         if y < 15 then if richtung = 2 then richtung  := 1;
         if y < 15 then if richtung = 4 then richtung  := 5;

       {nicht unten rausfliegen}
       if y > 150 then if richtung = 7 then if random(10) < 5
                                            then richtung := 6
                                            else richtung := 8;

         if y > 160 then if richtung = 5 then richtung  := 4;
         if y > 160 then if richtung = 1 then richtung  := 2;
         if y > 160 then if richtung = 6 then richtung  := 5;
         if y > 160 then if richtung = 8 then richtung  := 1;

       zustand:=richtung;
      end;

       if shotdelay > 0 then dec(shotdelay);

       zufall:=random(255);
       if zufall > 150 then if y < 190-mgspeed then if shotdelay = 0 then
        begin
         neu_shot(objnummer);
         shotdelay:=5;
        end;

end;
end;
{-----------------------------------------------------------------------------}
procedure ki_flieger_absturz(objnummer:word);  {Steuert Computerflieger}
var zufall : byte;
begin
 with objekte[objnummer] do
 begin

       richtung:= 7;
       zustand := richtung;
       if random (10) > 5 then neu_explosion(x+random(10)+5,y-random(20)+10);

       if y > 180 then {einschlag}
       begin
        neu_explosion(x+8,y+8);
        if typ = 1 then putsprite(x,y,seg(Fokkersprites[10]^),ofs(Fokkersprites[10]^),backaddr,16,16);
        if typ = 9 then putsprite(x,y,seg(camelsprites[10]^),ofs(camelsprites[10]^),backaddr,16,16);
        delobjekt(objnummer);
       end;
 end;
end;
{-----------------------------------------------------------------------------}


procedure objektverwaltung;
var lauf   : word;
    zufall : byte;
    objektnr:word;
begin

{ TYP : 1-Fokker 2-Wolke 3-Explosion 4-Britte 5-sterbender Britte 6-Schuss
        7-MG-Einschlag 8-player}


 for lauf:=1 to obzahl do
 with objekte[lauf] do
 begin
  case typ of
   {Fokker,camel}
   1,9 :begin                                 { Flieger per Random }

   if hitpoints > 0 then ki_flieger(lauf)
    else ki_flieger_absturz(lauf) {absturz}

   end;

   3 :begin
      if zustand < 7 then
      begin                                 { Explosion }
       {putsprite(x,y+8,seg(krater^),ofs(krater^),backaddr,12,3);}
       if del >= 3 then
       begin
        inc(zustand);
        del:=0;
       end
        else inc(del);
       end
        else delobjekt(lauf);
      end;

   {Britte}
   4 :begin
      if del = 127-speed then
      if zustand < 6 then inc(zustand) else zustand:=1;

      if hitpoints = 0 then
       begin
        typ:=5;
        zustand:=1;
        breite:=16;
        hoehe:=8;
        speed:=0;
       end;
      end;

   {sterbender Britte}
   5 :begin
      if zustand < 4 then
      begin                                 { Britte tot }
       if del >= 4 then
       begin
        inc(zustand);
        del:=0;
       end
        else inc(del);
       end
        else
        begin
        putsprite(x,y,seg(brittetot[5]^),ofs(brittetot[5]^),backaddr,16,8);
        delobjekt(lauf);
        end;
      end;

   {Schuss}
   6: begin
      for objektnr := 1 to obzahl do
      begin
      if x > objekte[objektnr].x then
      if x < objekte[objektnr].x+objekte[objektnr].breite then
      if y > objekte[objektnr].y then
      if y < objekte[objektnr].y+objekte[objektnr].hoehe then

      if objekte[objektnr].typ in [4,1,8,9,10] then
      begin
      neu_einschlag(x,y);
      if objekte[objektnr].hitpoints > 0 then
      begin
       if schussschaden then dec(objekte[objektnr].hitpoints);
       delobjekt(lauf);
       exit;
      end;
      end;
      end;

      if (y<199) and (y>=199-mgspeed) then neu_einschlag(x,y);

      if x >= 318-mgspeed-mgspeed then delobjekt(lauf)
      else if x <= mgspeed+mgspeed+2 then delobjekt(lauf)
      else if y <= mgspeed+mgspeed+2 then delobjekt(lauf)
      else if y >= 199-mgspeed then delobjekt(lauf);

      end;

   {Einschlag}
   7 :begin
      if zustand < 4 then
      begin                                 { Einschlag }
       if del >= 2 then
       begin
        inc(zustand);
        del:=0;
       end
        else inc(del);
       end
        else delobjekt(lauf);
      end;

   {Fokker:Player}
   8 :begin          { Flieger Steuerbar }

       player1:=lauf;   {Objektnummer fr Player1 abspeichern}

       if right then
       if wendedelay = 0 then
       begin
        dec(richtung);
        if richtung = 0   then richtung := 8;
        wendedelay:=wendigkeit;
       end;
       if left then
       if wendedelay = 0 then
       begin
        inc(richtung);
        if richtung = 9   then richtung := 1;
        wendedelay:=wendigkeit;
       end;
       zustand:=richtung;

       if wendedelay > 0 then dec(wendedelay);
       if shotdelay > 0 then dec(shotdelay);

       if space then if y < 190-mgspeed then if shotdelay = 0 then
        begin
        neu_shot(lauf);
        shotdelay:=5;
        end;

      if hitpoints = 0 then

      begin {absturz}
       richtung:= 7;
       zustand := richtung;
       if random (10) > 5 then neu_explosion(x+random(10)+5,y-random(20)+10);
      end;

       if y > 180 then {einschlag}
       begin
        neu_explosion(x,y);
        putsprite(x,y,seg(Fokkersprites[10]^),ofs(Fokkersprites[10]^),backaddr,16,16);
        player1da:=0;
        delobjekt(lauf);
       end;

      end;

   {camel:Player}
   10 :begin          { Flieger Steuerbar }

       player2:=lauf;   {Objektnummer fr Player2 abspeichern}

       if char_g then
       if wendedelay2 = 0 then
       begin
        dec(richtung);
        if richtung = 0   then richtung := 8;
        wendedelay2:=wendigkeit;
       end;
       if char_d then
       if wendedelay2 = 0 then
       begin
        inc(richtung);
        if richtung = 9   then richtung := 1;
        wendedelay2:=wendigkeit;
       end;
       zustand:=richtung;

       if wendedelay2 > 0 then dec(wendedelay2);
       if shotdelay > 0 then dec(shotdelay);

       if char_a then if y < 190-mgspeed then if shotdelay = 0 then
        begin
        neu_shot(lauf);
        shotdelay:=5;
        end;

      if hitpoints = 0 then

      begin {absturz}
       richtung:= 7;
       zustand := richtung;
       if random (10) > 5 then neu_explosion(x+random(10)+5,y-random(20)+10);
      end;

       if y > 180 then {einschlag}
       begin
        neu_explosion(x,y);
        putsprite(x,y,seg(camelsprites[10]^),ofs(camelsprites[10]^),backaddr,16,16);
        player2da:=0;
        delobjekt(lauf);
       end;

      end;

{ TYP : 1-Fokker 2-Wolke 3-Explosion 4-Britte 5-sterbender Britte 6-Schuss
        7-MG-Einschlag 8-player}

  end;
 end;
end;                                   { 77  ohne 99  cls 104 back      }
{-----------------------------------------------------------------------------}
procedure wertekorrektur;
var lauf   : word;
begin
 for lauf:=1 to obzahl do
 with objekte[lauf] do
 begin
  case typ of

   1,8,9,10 :begin                             { Raus -> rein auf anderer Seite }
      if x > 304 then x := 1;
      if y > 184 then y := 1;
      if x < 1 then x := 304;
      if y < 1 then y := 184;
      end;

   2 :begin                             { Wolke ... immer auf einer Hhe }
      if x > 320 then x := x-320;
      end;

   4 :begin                             { Britte... immer auf einer Hhe }
      if x < 1 then x := 312;
      end;

  end;
 end;
end;                                   { 77  ohne 99  cls 104 back      }
{-----------------------------------------------------------------------------}

{*****************************************************************************}
begin
init;

if timetest then starttime;

if timetest then zeitlauf := 1;

repeat
 begin
  {Randiommiger Artilleriebeschuss ?}
  if random(255) > 255 then neu_explosion(random(304),184-random(10));
  objektverwaltung;
  bewegen;
  wertekorrektur;
  scr_leeren;
  anzeigen;
  if timetest then inc(zeitlauf);
  if timetest then if zeitlauf = 100 then escape:=true;
 end;
until escape;


clearup;
if timetest then endtime;
end.
